diff --git a/src/etc/inc/filter.inc b/src/etc/inc/filter.inc
index d4d456bdf5af64d38cb842e1431b4f80be7a93c7..816eb8dbe4f535510f84b388cb01e1a6e218bbb8 100644
--- a/src/etc/inc/filter.inc
+++ b/src/etc/inc/filter.inc
@@ -2548,6 +2548,8 @@ function filter_nat_rules_generate() {
 
 			if (($ipproto == 'inet6') && is_stf_interface($natif)) {
 				$rdrif = $natif . "_stf";
+			} elseif ($natif == 'pppoe') {
+				$rdrif = 'pppoe';
 			} else {
 				$rdrif = $FilterIflist[$natif]['if'];
 			}
@@ -2584,7 +2586,11 @@ function filter_nat_rules_generate() {
 				}
 			}
 
-			$natif = $FilterIflist[$natif]['if'];
+			if ($natif == 'pppoe') {
+				$natif = 'pppoe';
+			} else {
+				$natif = $FilterIflist[$natif]['if'];
+			}
 
 			$reflection_type = "none";
 			if (($rule['natreflection'] != "disable") && ($dstaddr_port[0] != "0.0.0.0") && 
